      SUBROUTINE gpoint(spt,weight,npt1,nspd,LBIG)
!
!************************************************
!
!     GENERATE POINTS ON UNIT SPHERE
!
!************************************************
!
      IMPLICIT REAL*8(A-H,O-Z)
!
      INCLUDE 'param.inc'
!
      dimension spt(3,nspd),weight(nspd)
      DIMENSION PM(3),POS0(3),XX(LMAX1D),W(nspd)
!
!
      PI=4.D0*ATAN(1.D0)
!
      LPHI=3*LBIG
      LBIG=1.5*LBIG
!     GENERATE POINTS ON UNIT SPHERE
!
      CALL GRULE(LBIG,XX,W)
      NPT1=0
      DO 115 I=(LBIG+3)/2,LBIG
      J=I-(LBIG+1)/2
      W(I)=W(J)
      XX(I)=-XX(J)
  115 CONTINUE
!
      DO 110 J=1,LBIG
      Z=XX(J)
      RXY=SQRT(1.D0-Z*Z)
      DO 110 I=0,LPHI-1
      NPT1=NPT1+1
      PHI=PI*DFLOAT(2*I)/DFLOAT(LPHI)
!      INDEX=LBIG*I+J
      WEIGHT(NPT1)=W(J)
      SPT(1,NPT1)=COS(PHI)*RXY
      SPT(2,NPT1)=SIN(PHI)*RXY
      SPT(3,NPT1)=Z
!     write(6,*) npt1,(spt(j1,npt1),j1=1,3),weight(npt1)
 110  continue
!
      return
      end
      SUBROUTINE GRULE(N,X,W)
      IMPLICIT REAL*8 (A-H,O-Z)
!
!
!     DETERMINES THE (N+1)/2 NONNEGATIVE POINTS X(I) AND
!     THE CORRESPONDING WEIGHTS W(I) OF THE N-POINT
!     GAUSS-LEGENDRE INTEGRATION RULE, NORMALIZED TO THE
!     INTERVAL \-1,1\. THE X(I) APPEAR IN DESCENDING ORDER.
!
!     THIS ROUTINE IS FROM 'METHODS OF NUMERICAL INTEGRATION',
!     P.J. DAVIS AND P. RABINOWITZ, PAGE 369.
!
!
      DIMENSION X(N),W(N)
!      DATA ZERO,ONE,TWO,THREE,FOUR /0.0D0,1.0D0,2.0D0,3.0D0,4.0D0/
      parameter (zero=0.D0,one=1.D0,two=2.D0,three=3.d0,four=4.d0)
      PI=FOUR*ATAN(ONE)
      M=(N+1)/2
      E1=N*(N+1)
      DO 1 I=1,M
      T=DBLE(4*I-1)*PI/DBLE(4*N+2)
      X0=(1.D0-(1.D0-1.D0/N)/(8.D0*N*N))*COS(T)
!--->    ITERATE ON THE VALUE  (M.W. JAN. 1982)
      DO 2 IT=1,3
      PKM1=ONE
      PK=X0
      DO 3 K=2,N
      T1=X0*PK
      PKP1=T1-PKM1-(T1-PKM1)/K+T1
      PKM1=PK
      PK=PKP1
    3 CONTINUE
      DEN=ONE-X0*X0
      D1=N*(PKM1-X0*PK)
      DPN=D1/DEN
      D2PN=(2.D0*X0*DPN-E1*PK)/DEN
      D3PN=(4.D0*X0*D2PN+(2.D0-E1)*DPN)/DEN
      D4PN=(6.D0*X0*D3PN+(6.D0-E1)*D2PN)/DEN
      U=PK/DPN
      V=D2PN/DPN
      H=-U*(1.D0+.5D0*U*(V+U*(V*V-U*D3PN/(3.D0*DPN))))
      P=PK+H*(DPN+.5D0*H*(D2PN+H/3.D0*(D3PN+.25D0*H*D4PN)))
      DP=DPN+H*(D2PN+.5D0*H*(D3PN+H*D4PN/3.D0))
      H=H-P/DP
      X0=X0+H
    2 CONTINUE
      X(I)=X0
      FX=D1- &
       H*E1*(PK+.5D0*H*(DPN+H/3.D0*(D2PN+.25D0*H*(D3PN+.2D0*H*D4PN))))
      W(I)=TWO*(ONE-X(I)*X(I))/(FX*FX)
    1 CONTINUE
      IF(M+M.GT.N) X(M)=ZERO
      RETURN
      END

      SUBROUTINE gpointq(spt,weight,npt1,nspd)
!
!************************************************
!
!     GENERATE POINTS ON UNIT SPHERE
!
!************************************************
!
      IMPLICIT REAL*8(A-H,O-Z)
!
      INCLUDE 'param.inc'
!
      dimension spt(3,nspd),weight(nspd)
      include 'quads.h'
      include 'quad2.h'
!
!     Different concept, use quadratures if possible
      MINDEX=2*LMAX1D*LMAX1D-LMAX1D
      LM=LMAX1D
      idesign=0
      if(mindex.le.144)then
        npt1=144
        do j=1,144
                spt(1,j)=x144(j)
                spt(2,j)=y144(j)
                spt(3,j)=z144(j)
                weight(j)=w144(j)
        enddo
      else if(mindex.le.169)then
        npt1=169
        do j=1,169
                spt(1,j)=x169(j)
                spt(2,j)=y169(j)
                spt(3,j)=z169(j)
                weight(j)=w169(j)
        enddo
      else if(mindex.le.196)then
        npt1=196
        do j=1,196
                spt(1,j)=x196(j)
                spt(2,j)=y196(j)
                spt(3,j)=z196(j)
                weight(j)=w196(j)
        enddo
      else if(mindex .le. 225)then
        npt1=225
        do j=1,225
                spt(1,j)=x225(j)
                spt(2,j)=y225(j)
                spt(3,j)=z225(j)
                weight(j)=w225(j)
        enddo
      else if(mindex .le. 256)then
        npt1=256
        do j=1,256
                spt(1,j)=x256(j)
                spt(2,j)=y256(j)
                spt(3,j)=z256(j)
                weight(j)=w256(j)
        enddo
      else if(mindex .le. 289)then
        npt1=289
        do j=1,289
                spt(1,j)=x289(j)
                spt(2,j)=y289(j)
                spt(3,j)=z289(j)
                weight(j)=w289(j)
        enddo
      else if( LM .eq. 13)then
        npt1=324
        do j=1,324
                spt(1,j)=x324(j)
                spt(2,j)=y324(j)
                spt(3,j)=z324(j)
                weight(j)=w324(j)
        enddo
      else
        call gpoint(spt,weight,npt1)
        idesign=1
        write(6,*)'   Fit using a Gaussian quadrature with ',npt1,' points'
      endif
      if( idesign .eq. 0) then
        write(6,*)'   Fit using a Design quadrature with ',npt1,' points'
      endif
      do j=1,npt1
        r=spt(1,j)*spt(1,j)+spt(2,j)*spt(2,j)+spt(3,j)*spt(3,j)
        r=sqrt(r)
        spt(1,j)=spt(1,j)/r
        spt(2,j)=spt(2,j)/r
        spt(3,j)=spt(3,j)/r
      enddo
      return
      end

