      SUBROUTINE INIT(valence)
!
!     Reads case.struct and case.clmsum files
!     Taken from aim
!
      use rad
      use sphe
      use blank
      use crit
      use zsphe
      use atpos
      implicit none
      INCLUDE 'param.inc'

      real*8 tau,otau,oiz,invoiz,br1,br2,br3,br4
      real*8 a,alpha,beta,gamma,pos1,pos2,pos3
      real*8 gamma1
      real*8 aix,aiy,aiz,rmtt,fadd,sqfp
      real*8 pi,tpi,fpi,sqpi,sqtpi
      real*8 mat,y,yp1,ypn
      real*8 x1,x2,x3,f1,f2,f3,tmp

      integer iz,iord,iszero,iat
      integer i,j,jatom,index,jrj,nat,iform1,mu,i1,j1,ll
      integer l,iclm,i2,k,itmp
      integer ipiv,id,info,nato,ndif

      CHARACTER*4 LATTIC,cform
      CHARACTER*10 TITEL

      logical ortho,deb,valence

      COMMON /DEBUG/ deb
      COMMON /SYM2/ tau(3,NSYM),otau(3,NSYM),oiz(3,3,NSYM), &
         invoiz(3,3,NSYM),iz(3,3,NSYM),iord
      COMMON /BRAV/ BR1(3,3),BR2(3,3),br3(3,3),br4(3,3)
      COMMON /LATT/ A(3),alpha,beta,gamma,gamma1,ortho

      COMMON /CTES/ pi,tpi,fpi,sqpi,sqtpi
!
      DIMENSION TITEL(8)   
      DIMENSION mat(3,3),y(3,3),ipiv(3)
      real*8,allocatable :: z(:)    ! Z(NATO)
      pi=acos(-1.d0)
      tpi=2.d0*pi
      fpi=4.d0*pi
      sqpi=sqrt(pi)
      sqtpi=sqrt(tpi)
      sqfp=2.d0*sqrt(pi)
      npc=0
!     
!     
      READ(8,102) TITEL                                              
      READ(8,103) LATTIC,NAT,cform
!     Stop for rhombohedral
!     if(LATTIC(1:1).eq.'R')then
!       write(*,*)'Sorry, Rhombohedral Cells not implimented yet'
!       stop
!     endif
      READ(8,100) A,alpha,beta,gamma
      WRITE(6,119) TITEL                                             
      WRITE(6,104) LATTIC,NAT                                        
      WRITE(6,105) A       
      nato=nat
      ndif=nat*48
      allocate( RM(NRAD,NATO),JRI(NATO),z(nato) )                            
      allocate( CLM(NRAD,NCOM,NATO),CLM2(NRAD,NCOM,NATO),LM(2,NCOM,NATO),LMMAX(NATO) ) 
      allocate( POS(3,NDIF),RMT(NATO),ROTLOC(3,3,NATO),DX(NATO),RNOT(NATO) )
      allocate( IATNR(NDIF),IOP(NDIF),MULT(NATO),ZZ(NDIF),ANAME(NATO) )
      assign 2021 to iform1
 2021 FORMAT(3X,4E19.12)

      call gen_brav(LATTIC)
!     
!.... READ NUMBER OF DIFFERENT ATOMS(MAX 17)                         
!.... READ AT.NR (EQ.STRUCT) AND POSITION                            
!     
!     WRITE(6,106)((BR1(I,J),I=1,3),J=1,3)                           
!     WRITE(6,106)((BR3(I,J),I=1,3),J=1,3)                           
!     WRITE(6,106)((BR4(I,J),I=1,3),J=1,3)                           
!      WRITE(6,108)                                                   
      INDEX=0                                                        
      DO JATOM=1,NAT                                                  
!          if(index.gt. ndif) stop 'NDIF too small'
        READ(8,1012) IATNR(JATOM),POS(1,JATOM),POS(2,JATOM), &
           POS(3,JATOM),MULT(JATOM)
!     
!     POS IATNR: MEANS CUB SYM
!     
!     NEG IATNR: MEANS NO CUB SYM
!     
        DO MU=1,MULT(JATOM)-1                                       
          INDEX=INDEX+1
!          if(index.gt. ndif) stop 'NDIF too small'
          READ(8,1013) IAT,POS1, &
             POS2,POS3
        enddo
!.... READ(RADIAL PARAMETERS, Z, SYMMETRY OPERATIONS                 
!     
        READ(8,113) ANAME(JATOM),JRI(JATOM),RNOT(JATOM),RMTT,Z(JATOM)
        DX(JATOM)=LOG(RMTT/RNOT(JATOM)) / (JRI(JATOM)-1)
        READ(8,1051) ((ROTLOC(I1,J1,JATOM),I1=1,3),J1=1,3)
      enddo
      NDAT=NAT
      READ(8,114) IORD                                               
      DO I=1,IORD                                                    
        READ(8,115) ((IZ(I1,I2,I),I1=1,3),TAU(I2,I),I2=1,3)
      enddo
!
!.... READ LMMAX OF ALL ATOMS
!.... READ CLM'S, GENERATE R-MESH
!     
      READ(9,2032)
      DO JATOM=1,NAT
        JRJ=JRI(JATOM)
        do i=1,JRJ
          RM(I,JATOM)=RNOT(JATOM)*EXP((I-1)*DX(JATOM))
        enddo
        RMT(JATOM)=RM(JRJ,JATOM)
        READ(9,118) LL
        LMMAX(JATOM)=LL
        DO L=1,LL
          READ(9,2010) LM(1,L,JATOM),LM(2,L,JATOM)
          if(lm(1,l,jatom).gt. lmax2) stop 'lmax2 too small'
          READ(9,iform1) (CLM(I,L,JATOM),I=1,JRJ)
          READ(9,2031)
        end do    
!
!       Alter for case.clmsum
        if(.not. valence)then
        do i=1,jrj
          clm(i,1,jatom)=clm(i,1,jatom)/sqfp
        enddo
        endif

        READ(9,2033)
!       WRITE(6,117) JATOM,LL,(LM(1,L,JATOM),LM(2,L ,JATOM),L=1,LL)
      enddo                          
!     
!.... READ FOURIER COEFFICIENTS, REC.LATTIC VECTORS(IN 2*PI/A)
!.... GENERATE STAR
!     
      call OUTIN(ICLM,LATTIC,cform,fadd,ortho,br3,br4)

!.... Endo of initialization
     
      return


 121  FORMAT('0 CMIN=',F12.5,'    CMAX=',F12.5)
 100  FORMAT(6F10.5)
 101  FORMAT(6I5)
 102  FORMAT(8A10)
 103  FORMAT(A4,23X,I3,1x,a4,/,4X,A4)
 104  FORMAT(1X,A10,' LATTIC',10X,I5,' - ATOMS')
 105  FORMAT(' LATTIC CONSTANTS:',F10.7,2x,F10.7,2x,F10.7/)
 106  FORMAT(' BRAVAIS MATRIX:',/,3(10X,3F10.5,/))
 107  FORMAT(2I5,3F10.3)
 108  FORMAT('0ATOMNR,OPERATION  POS X    POS Y     POS Z')
 109  FORMAT('0ENDPOINTS OF PLOT (X,Y,Z):'/)
 110  FORMAT &
         ('0NUMBER OF PLOTTING POINTS IN X AND Y - DIRECTION:',2I5, &
          /' NUMBER OF POINTS IN PRINTOUT:' &
         ,2I5)                           
 111  FORMAT(1H0,A4,10X,'CHARGE IN:',A4,/)
 112  FORMAT(A4,a4,/,A4,a4,a4)
 113  FORMAT(A10,5X,I5,5X,F10.5,5X,F10.5,5X,F5.2)
 114  FORMAT(I4)
 115  FORMAT(3(3I2,F10.5,/))
 116  FORMAT(3X,5E13.7)
 117  FORMAT('0ATOM ',I4,'  LMMAX:',I4,'  LM:',11(i3,2X))
 118  FORMAT(/,15X,I3,//)
 119  FORMAT(1H1,8A10)
 1012 FORMAT(4X,I4,4X,F10.7,3X,F10.7,3X,F10.7,/15X,I2)
 1013 FORMAT(4X,I4,4X,F10.7,3X,F10.7,3X,F10.7)
 1051 FORMAT(20X,3F10.8)
 2010 FORMAT(15X,I3,5X,I2,/)
 2031 FORMAT(/)
 2032 FORMAT(//)
 2033 FORMAT(///)
      end

