      SUBROUTINE MAIN1 (valence)
!
!     Code to look at continuity of values and radial derivatives
!     at RMTs
!     L. D. Marks, March 2006
!
      use rad
      use sphe
      use atpos
      use blank
      IMPLICIT NONE

      CHARACTER*4 switch

      logical ortho,deb,debold,ssave
      integer L2, LL, M,IDX,LLBIG
      real*8 BR1,BR2,br3,br4,T,rt2,rho3,T2,gsum,csum,gerr,cerr
      real*8 tau,otau,oiz,invoiz,tpi,a,alpha,beta,gamma,gamma1
      real*8 v,pi,dmax,dstmax,vt1,dir,rad2,ZTMP,drr,CTMP

      integer iz,iord
      integer lwork,index,jj,iat,ipos,i,j
      integer iatinit,iposinit,npmax,npoints,nstep

      INCLUDE 'param.inc'
      COMMON /DEBUG/ deb
      COMMON /SYM2/ tau(3,NSYM),otau(3,NSYM),oiz(3,3,NSYM), &
         invoiz(3,3,NSYM),iz(3,3,NSYM),iord
      COMMON /BRAV/ BR1(3,3),BR2(3,3),br3(3,3),br4(3,3)
      COMMON /LATT/ A(3),alpha,beta,gamma,gamma1,ortho
      DIMENSION V(3),vt1(3),a2(3)
      integer igmode, LMM, L,ist,IR
      logical trust,inter,valence
      common /ldmopts/igmode,trust
      real*16 wsum
      real*8 grho1(3),grho2(3),hrho1(3,3),hrho2(3,3),a2,tcc
      real*8 rho1,rho2,r,radd,rota1(3),dr1,dr2,del,T3,aa(3)
!
      integer LBIG, npt1,ibest,ipbest,jatom
      parameter (LBIG=3*(lmax2+1)*(lmax2+1) )
      complex*16  YL((lbig) )
      real*8 PROJ1(LBIG),PROJ2(LBIG), PG1(LBIG),PG2(LBIG)
      real*8 spt(3,lbig),weight(lbig),thold(lbig)
      
      rt2=sqrt(2.D0)
      tpi=2.0*acos(-1.d0)
      pi=acos(-1.d0)
      
      lwork=9

      deb=.false.
!     Change to false for case.clmsum
!     valence=.true.
!
!     Use conventional Gauss-Legendre quadrature
      igmode=1

!     READ STRUCT AND CLMSUM FILES
!
      call init(valence)
!
!     Loop over all atoms
      do jatom=1,ndat
      LMM=LMMAX(JATOM)
!     Largest L value, to set number of points for quadrature
      LLBIG=0
      do L=1,LMM
        J=abs(LM(1,L,jatom))
        if(j.gt.LLBIG)LLBIG=j
      enddo
!     CHECK THIS, WHY DO WE NEED TO ADD 1 ??
!     llbig=llbig+2
      call gpoint(spt,weight,npt1,lbig,llbig)
!     Get normalization right
      wsum=0.D0
      do j=1,npt1
        wsum=wsum+weight(j)
      enddo
      wsum=2.d0*tpi/wsum
      do j=1,npt1
        weight(j)=weight(j)*wsum
      enddo      
66    format(i4,3F12.6,F12.8)
!     Target atom radius
      Radd = RMT(jatom)
!     Step size
      del = 1.D-6*Radd
      Rad2 = Radd+del
      Wsum=0.D0
      proj1(1:NPT1)=0.D0
      proj2(1:NPT1)=0.D0
      PG1(1:NPT1)=0.D0
      PG2(1:NPT1)=0.D0
      LMM=LMMAX(JATOM)
      write(6,75)jatom,(pos(j,jatom),j=1,3)
75    format('Atom ',i3,' X=',F9.6,' Y=',F9.6,' Z=',F9.6)
      if(deb)write(6,*)'Point     PW           CLM        dPW/dR         dCLM/dR'
      CSUM=0.D0
      GSUM=0.D0
      CERR=0.D0
      GERR=0.D0
      ZTMP=0.D0
      CTMP=0.D0
      do j=1,npt1
!        Quadrature point
         a2(1)=spt(1,j)
         a2(2)=spt(2,j)
         a2(3)=spt(3,j)
         CALL rotat (a2,rotloc(1,1,jatom))
         CALL YLMB (a2,lmax2,YL)
!        Transform to reduced position
         do jj=1,3
                vt1(jj)=spt(1,j)*BR4(1,jj)+spt(2,j)*BR4(2,jj)+spt(3,j)*BR4(3,jj)
         enddo
!
!        Interstitial density/derivative
         v(1)=pos(1,jatom) +radd*vt1(1) !/a(1)
         v(2)=pos(2,jatom) +radd*vt1(2) !/a(2)
         v(3)=pos(3,jatom) +radd*vt1(3) !/a(3)
         call interst(v,rho1)
         v(1)=pos(1,jatom) +rad2*vt1(1) !/a(1)
         v(2)=pos(2,jatom) +rad2*vt1(2) !/a(2)
         v(3)=pos(3,jatom) +rad2*vt1(3) !/a(3)
         call interst(v,rho2)
         dr1=(rho1-rho2)/del
         call CHARGE(a2,rho2,jri(jatom),Radd,JATOM,IATNR(jatom))
!
!        Project onto harmonics
         rho3=0.
         dr2=0.
         do L=1,LMM
                IR=jri(jatom)
                call  RADIAL(CLM(1,L,JATOM),T,Radd,IR,JATOM)
                call  RADIAL(CLM(1,L,JATOM),T2,Rad2,IR,JATOM)
                T2=(T-T2)
                LL=LM(1,L,JATOM)
                L2=IABS(LL)                                           
                M=LM(2,L,JATOM)                                                 
                IF( M .EQ. 0)THEN
                        IDX=L2*(L2+1)+1
                        TCC= YL(IDX)
                ELSE
                        IDX=L2*(L2+1)-M+1
                        IF ( LL .GT. 0 )THEN
                                TCC=rt2*dble(YL(IDX))
                        ELSE
                                TCC=-rt2*dimag(YL(IDX))
                        ENDIF
                ENDIF
                
               proj1(L)=proj1(L)+TCC*rho1*weight(j)
               proj2(L)=proj2(L)+TCC*rho2*weight(j)
               PG1(L)=PG1(L)+TCC*dr1*weight(j)
               rho3=rho3+TCC*T
               dr2=dr2+TCC*T2
               THOLD(L)=TCC
         enddo
         dr2=dr2/del
         do L=1,LMM
               PG2(L)=PG2(L)+THOLD(L)*dr2*weight(j)
         enddo
         if(deb)write(6,100)j,rho1,rho2,dr1,dr2
         cerr=cerr+abs(rho1-rho2)*weight(j)
         gerr=gerr+abs(dr1-dr2)*weight(j)
         csum=csum+abs(rho1)*weight(j)
         gsum=gsum+abs(dr1)*weight(j)
100      format(i4,5D14.6)
         ZTMP=ZTMP+(dr1-dr2)*weight(j)
         CTMP=CTMP+(rho1-rho1)*weight(j)
      enddo
!      cerr=(cerr/csum)
!      gerr=(gerr/gsum)
!      J=JRI(JATOM)
!      WSUM=4.D0*acos(-1.D0)
!      ZTMP=ZTMP/WSUM
!      CTMP=CTMP/WSUM
!      CERR=CERR/WSUM
!      GERR=GERR/WSUM
!      CSUM=CSUM/WSUM
!      GSUM=GSUM/WSUM
      if(deb)write(6,*)' '
      write(6,*)'   L    M      PW              CLM           dPW/dR            dCLM/dR'
      do L=1,LMM
!         T=CLM(J,L,JATOM)/(Radd*Radd)
         write(6,10)LM(1,L,jatom),LM(2,L,jatom),proj1(L),proj2(L),PG1(L),PG2(L)
10       format(2i5,4E16.8)
      enddo
101   format('Atom ',i3,' ',a,' | RMT Charge ',F7.3,' Grad ',F7.3,' | Step Charge ',F8.5,',',F8.5, &
        ' Gradient ', F8.4,',',F8.4,' ',a) 
      write(6,101)jatom,aname(jatom)(1:4),csum,gsum,cerr,CTMP,gerr,ZTMP,aname(jatom)(1:4)
      write(*,101)jatom,aname(jatom)(1:4),csum,gsum,cerr,CTMP,gerr,ZTMP,aname(jatom)(1:4)
      write(6,*)' '
      enddo
!

 112  FORMAT(A4)
      END                                                   

